Index: XIOS/trunk/src/interface/fortran_attr/gridgroup_interface_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/gridgroup_interface_attr.F90	(revision 791)
+++ XIOS/trunk/src/interface/fortran_attr/gridgroup_interface_attr.F90	(revision 817)
@@ -52,65 +52,65 @@
 
 
-    SUBROUTINE cxios_set_gridgroup_mask1(gridgroup_hdl, mask1, extent) BIND(C)
+    SUBROUTINE cxios_set_gridgroup_mask_1d(gridgroup_hdl, mask_1d, extent) BIND(C)
       USE ISO_C_BINDING
       INTEGER (kind = C_INTPTR_T), VALUE       :: gridgroup_hdl
-      LOGICAL (KIND=C_BOOL)     , DIMENSION(*) :: mask1
+      LOGICAL (KIND=C_BOOL)     , DIMENSION(*) :: mask_1d
       INTEGER (kind = C_INT), DIMENSION(*)     :: extent
-    END SUBROUTINE cxios_set_gridgroup_mask1
+    END SUBROUTINE cxios_set_gridgroup_mask_1d
 
-    SUBROUTINE cxios_get_gridgroup_mask1(gridgroup_hdl, mask1, extent) BIND(C)
+    SUBROUTINE cxios_get_gridgroup_mask_1d(gridgroup_hdl, mask_1d, extent) BIND(C)
       USE ISO_C_BINDING
       INTEGER (kind = C_INTPTR_T), VALUE       :: gridgroup_hdl
-      LOGICAL (KIND=C_BOOL)     , DIMENSION(*) :: mask1
+      LOGICAL (KIND=C_BOOL)     , DIMENSION(*) :: mask_1d
       INTEGER (kind = C_INT), DIMENSION(*)     :: extent
-    END SUBROUTINE cxios_get_gridgroup_mask1
+    END SUBROUTINE cxios_get_gridgroup_mask_1d
 
-    FUNCTION cxios_is_defined_gridgroup_mask1(gridgroup_hdl) BIND(C)
+    FUNCTION cxios_is_defined_gridgroup_mask_1d(gridgroup_hdl) BIND(C)
       USE ISO_C_BINDING
-      LOGICAL(kind=C_BOOL) :: cxios_is_defined_gridgroup_mask1
+      LOGICAL(kind=C_BOOL) :: cxios_is_defined_gridgroup_mask_1d
       INTEGER (kind = C_INTPTR_T), VALUE :: gridgroup_hdl
-    END FUNCTION cxios_is_defined_gridgroup_mask1
+    END FUNCTION cxios_is_defined_gridgroup_mask_1d
 
 
-    SUBROUTINE cxios_set_gridgroup_mask2(gridgroup_hdl, mask2, extent) BIND(C)
+    SUBROUTINE cxios_set_gridgroup_mask_2d(gridgroup_hdl, mask_2d, extent) BIND(C)
       USE ISO_C_BINDING
       INTEGER (kind = C_INTPTR_T), VALUE       :: gridgroup_hdl
-      LOGICAL (KIND=C_BOOL)     , DIMENSION(*) :: mask2
+      LOGICAL (KIND=C_BOOL)     , DIMENSION(*) :: mask_2d
       INTEGER (kind = C_INT), DIMENSION(*)     :: extent
-    END SUBROUTINE cxios_set_gridgroup_mask2
+    END SUBROUTINE cxios_set_gridgroup_mask_2d
 
-    SUBROUTINE cxios_get_gridgroup_mask2(gridgroup_hdl, mask2, extent) BIND(C)
+    SUBROUTINE cxios_get_gridgroup_mask_2d(gridgroup_hdl, mask_2d, extent) BIND(C)
       USE ISO_C_BINDING
       INTEGER (kind = C_INTPTR_T), VALUE       :: gridgroup_hdl
-      LOGICAL (KIND=C_BOOL)     , DIMENSION(*) :: mask2
+      LOGICAL (KIND=C_BOOL)     , DIMENSION(*) :: mask_2d
       INTEGER (kind = C_INT), DIMENSION(*)     :: extent
-    END SUBROUTINE cxios_get_gridgroup_mask2
+    END SUBROUTINE cxios_get_gridgroup_mask_2d
 
-    FUNCTION cxios_is_defined_gridgroup_mask2(gridgroup_hdl) BIND(C)
+    FUNCTION cxios_is_defined_gridgroup_mask_2d(gridgroup_hdl) BIND(C)
       USE ISO_C_BINDING
-      LOGICAL(kind=C_BOOL) :: cxios_is_defined_gridgroup_mask2
+      LOGICAL(kind=C_BOOL) :: cxios_is_defined_gridgroup_mask_2d
       INTEGER (kind = C_INTPTR_T), VALUE :: gridgroup_hdl
-    END FUNCTION cxios_is_defined_gridgroup_mask2
+    END FUNCTION cxios_is_defined_gridgroup_mask_2d
 
 
-    SUBROUTINE cxios_set_gridgroup_mask3(gridgroup_hdl, mask3, extent) BIND(C)
+    SUBROUTINE cxios_set_gridgroup_mask_3d(gridgroup_hdl, mask_3d, extent) BIND(C)
       USE ISO_C_BINDING
       INTEGER (kind = C_INTPTR_T), VALUE       :: gridgroup_hdl
-      LOGICAL (KIND=C_BOOL)     , DIMENSION(*) :: mask3
+      LOGICAL (KIND=C_BOOL)     , DIMENSION(*) :: mask_3d
       INTEGER (kind = C_INT), DIMENSION(*)     :: extent
-    END SUBROUTINE cxios_set_gridgroup_mask3
+    END SUBROUTINE cxios_set_gridgroup_mask_3d
 
-    SUBROUTINE cxios_get_gridgroup_mask3(gridgroup_hdl, mask3, extent) BIND(C)
+    SUBROUTINE cxios_get_gridgroup_mask_3d(gridgroup_hdl, mask_3d, extent) BIND(C)
       USE ISO_C_BINDING
       INTEGER (kind = C_INTPTR_T), VALUE       :: gridgroup_hdl
-      LOGICAL (KIND=C_BOOL)     , DIMENSION(*) :: mask3
+      LOGICAL (KIND=C_BOOL)     , DIMENSION(*) :: mask_3d
       INTEGER (kind = C_INT), DIMENSION(*)     :: extent
-    END SUBROUTINE cxios_get_gridgroup_mask3
+    END SUBROUTINE cxios_get_gridgroup_mask_3d
 
-    FUNCTION cxios_is_defined_gridgroup_mask3(gridgroup_hdl) BIND(C)
+    FUNCTION cxios_is_defined_gridgroup_mask_3d(gridgroup_hdl) BIND(C)
       USE ISO_C_BINDING
-      LOGICAL(kind=C_BOOL) :: cxios_is_defined_gridgroup_mask3
+      LOGICAL(kind=C_BOOL) :: cxios_is_defined_gridgroup_mask_3d
       INTEGER (kind = C_INTPTR_T), VALUE :: gridgroup_hdl
-    END FUNCTION cxios_is_defined_gridgroup_mask3
+    END FUNCTION cxios_is_defined_gridgroup_mask_3d
 
 